#ifdef LOOP1
        cm_subT[k][0][0] = d11_18 * T[k].pV[0]->r[0]  +
                            d7_36 * (T[k].pV[1]->r[0] + T[k].pV[2]->r[0]);
        cm_subT[k][0][1] = d11_18 * T[k].pV[0]->r[1]  +
                            d7_36 * (T[k].pV[1]->r[1] + T[k].pV[2]->r[1]);
        cm_subT[k][0][2] = d11_18 * T[k].pV[0]->r[2]  +
                            d7_36 * (T[k].pV[1]->r[2] + T[k].pV[2]->r[2]);

        cm_subT[k][1][0] = d11_18 * T[k].pV[1]->r[0]  +
                            d7_36 * (T[k].pV[2]->r[0] + T[k].pV[0]->r[0]);
        cm_subT[k][1][1] = d11_18 * T[k].pV[1]->r[1]  +
                            d7_36 * (T[k].pV[2]->r[1] + T[k].pV[0]->r[1]);
        cm_subT[k][1][2] = d11_18 * T[k].pV[1]->r[2]  +
                            d7_36 * (T[k].pV[2]->r[2] + T[k].pV[0]->r[2]);

        cm_subT[k][2][0] = d11_18 * T[k].pV[2]->r[0]  +
                            d7_36 * (T[k].pV[0]->r[0] + T[k].pV[1]->r[0]);
        cm_subT[k][2][1] = d11_18 * T[k].pV[2]->r[1]  +
                            d7_36 * (T[k].pV[0]->r[1] + T[k].pV[1]->r[1]);
        cm_subT[k][2][2] = d11_18 * T[k].pV[2]->r[2]  +
                            d7_36 * (T[k].pV[0]->r[2] + T[k].pV[1]->r[2]);
#undef LOOP1
#endif /* LOOP1 */


#ifdef LOOP2
                /* loop over vertices (or edges) of current triangle */
                /* TRIANGLE (m=)0, VERTEX (j=)0 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[0]->n[0], E[k].pT[0]->pV[0]->r )  -
                          DOT( E[k].pT[0]->n[0], E[k].pT[0]->pV[1]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[0]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[0][0] += ( DOT(etahat,E[k].pT[0]->n[0]) *
                                   E[k].pT[0]->pV[0]->v[0] +
                                   E[k].pT[0]->n[0][0] *
                                   DOT(etahat,E[k].pT[0]->pV[0]->v) ) / alt;
                    shr[0][1] += ( DOT(etahat,E[k].pT[0]->n[0]) *
                                   E[k].pT[0]->pV[0]->v[1] +
                                   E[k].pT[0]->n[0][1] *
                                   DOT(etahat,E[k].pT[0]->pV[0]->v) ) / alt;
                    shr[0][2] += ( DOT(etahat,E[k].pT[0]->n[0]) *
                                   E[k].pT[0]->pV[0]->v[2] +
                                   E[k].pT[0]->n[0][2] *
                                   DOT(etahat,E[k].pT[0]->pV[0]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[0] += DOT(E[k].pT[0]->n[0], E[k].pT[0]->pV[0]->v) /
                                                alt;

                /* TRIANGLE (m=)0, VERTEX (j=)1 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[0]->n[1], E[k].pT[0]->pV[1]->r )  -
                          DOT( E[k].pT[0]->n[1], E[k].pT[0]->pV[2]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[0]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[0][0] += ( DOT(etahat,E[k].pT[0]->n[1]) *
                                   E[k].pT[0]->pV[1]->v[0] +
                                   E[k].pT[0]->n[1][0] *
                                   DOT(etahat,E[k].pT[0]->pV[1]->v) ) / alt;
                    shr[0][1] += ( DOT(etahat,E[k].pT[0]->n[1]) *
                                   E[k].pT[0]->pV[1]->v[1] +
                                   E[k].pT[0]->n[1][1] *
                                   DOT(etahat,E[k].pT[0]->pV[1]->v) ) / alt;
                    shr[0][2] += ( DOT(etahat,E[k].pT[0]->n[1]) *
                                   E[k].pT[0]->pV[1]->v[2] +
                                   E[k].pT[0]->n[1][2] *
                                   DOT(etahat,E[k].pT[0]->pV[1]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[0] += DOT(E[k].pT[0]->n[1], E[k].pT[0]->pV[1]->v) /
                                                alt;

                /* TRIANGLE (m=)0, VERTEX (j=)2 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[0]->n[2], E[k].pT[0]->pV[2]->r )  -
                          DOT( E[k].pT[0]->n[2], E[k].pT[0]->pV[0]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[0]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[0][0] += ( DOT(etahat,E[k].pT[0]->n[2]) *
                                   E[k].pT[0]->pV[2]->v[0] +
                                   E[k].pT[0]->n[2][0] *
                                   DOT(etahat,E[k].pT[0]->pV[2]->v) ) / alt;
                    shr[0][1] += ( DOT(etahat,E[k].pT[0]->n[2]) *
                                   E[k].pT[0]->pV[2]->v[1] +
                                   E[k].pT[0]->n[2][1] *
                                   DOT(etahat,E[k].pT[0]->pV[2]->v) ) / alt;
                    shr[0][2] += ( DOT(etahat,E[k].pT[0]->n[2]) *
                                   E[k].pT[0]->pV[2]->v[2] +
                                   E[k].pT[0]->n[2][2] *
                                   DOT(etahat,E[k].pT[0]->pV[2]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[0] += DOT(E[k].pT[0]->n[2], E[k].pT[0]->pV[2]->v) /
                                                alt;




                /* loop over vertices (or edges) of current triangle */
                /* TRIANGLE (m=)1, VERTEX (j=)0 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[1]->n[0], E[k].pT[1]->pV[0]->r )  -
                          DOT( E[k].pT[1]->n[0], E[k].pT[1]->pV[1]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[1]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[1][0] += ( DOT(etahat,E[k].pT[1]->n[0]) *
                                   E[k].pT[1]->pV[0]->v[0] +
                                   E[k].pT[1]->n[0][0] *
                                   DOT(etahat,E[k].pT[1]->pV[0]->v) ) / alt;
                    shr[1][1] += ( DOT(etahat,E[k].pT[1]->n[0]) *
                                   E[k].pT[1]->pV[0]->v[1] +
                                   E[k].pT[1]->n[0][1] *
                                   DOT(etahat,E[k].pT[1]->pV[0]->v) ) / alt;
                    shr[1][2] += ( DOT(etahat,E[k].pT[1]->n[0]) *
                                   E[k].pT[1]->pV[0]->v[2] +
                                   E[k].pT[1]->n[0][2] *
                                   DOT(etahat,E[k].pT[1]->pV[0]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[1] += DOT(E[k].pT[1]->n[0], E[k].pT[1]->pV[0]->v) /
                                                alt;

                /* TRIANGLE (m=)1, VERTEX (j=)1 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[1]->n[1], E[k].pT[1]->pV[1]->r )  -
                          DOT( E[k].pT[1]->n[1], E[k].pT[1]->pV[2]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[1]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[1][0] += ( DOT(etahat,E[k].pT[1]->n[1]) *
                                   E[k].pT[1]->pV[1]->v[0] +
                                   E[k].pT[1]->n[1][0] *
                                   DOT(etahat,E[k].pT[1]->pV[1]->v) ) / alt;
                    shr[1][1] += ( DOT(etahat,E[k].pT[1]->n[1]) *
                                   E[k].pT[1]->pV[1]->v[1] +
                                   E[k].pT[1]->n[1][1] *
                                   DOT(etahat,E[k].pT[1]->pV[1]->v) ) / alt;
                    shr[1][2] += ( DOT(etahat,E[k].pT[1]->n[1]) *
                                   E[k].pT[1]->pV[1]->v[2] +
                                   E[k].pT[1]->n[1][2] *
                                   DOT(etahat,E[k].pT[1]->pV[1]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[1] += DOT(E[k].pT[1]->n[1], E[k].pT[1]->pV[1]->v) /
                                                alt;

                /* TRIANGLE (m=)1, VERTEX (j=)2 */
                    /* calculate altitude to current vertex */
                    alt = DOT( E[k].pT[1]->n[2], E[k].pT[1]->pV[2]->r )  -
                          DOT( E[k].pT[1]->n[2], E[k].pT[1]->pV[0]->r );

                    if (alt < .001) {
                        fprintf(outfile, "    WARNING:  alt = %13.4e  E[%d]  "
                          "T[%d]\n", alt, k, E[k].pT[1]-T );
                        fprintf(outfile, "    (not skipping viscous-force "
                          "calculation, but probably should)\n");
                    }

                    /* loop over cartesian coords and calculate terms under
                     * sum in shear expression (vector; see GRR viscosity
                     * notes, eq. "11")  [E.n, pV->r bugs fixed, 1991.08.08] */
                    shr[1][0] += ( DOT(etahat,E[k].pT[1]->n[2]) *
                                   E[k].pT[1]->pV[2]->v[0] +
                                   E[k].pT[1]->n[2][0] *
                                   DOT(etahat,E[k].pT[1]->pV[2]->v) ) / alt;
                    shr[1][1] += ( DOT(etahat,E[k].pT[1]->n[2]) *
                                   E[k].pT[1]->pV[2]->v[1] +
                                   E[k].pT[1]->n[2][1] *
                                   DOT(etahat,E[k].pT[1]->pV[2]->v) ) / alt;
                    shr[1][2] += ( DOT(etahat,E[k].pT[1]->n[2]) *
                                   E[k].pT[1]->pV[2]->v[2] +
                                   E[k].pT[1]->n[2][2] *
                                   DOT(etahat,E[k].pT[1]->pV[2]->v) ) / alt;

                    /* do same for bulk expression (p. 6), except scalar */
                    blk[1] += DOT(E[k].pT[1]->n[2], E[k].pT[1]->pV[2]->v) /
                                                alt;
#undef LOOP2
#endif /* LOOP2 */
